libzypp: std Namespace Reference

libzypp 17.38.14

std Namespace Reference

## Namespaces
namespace | detail

## Classes
struct | make_void
struct | remove_cvref
struct | conjunction
struct | conjunction< B1 >
struct | conjunction< B1, Bn... >
struct | disjunction
struct | disjunction< B1 >
struct | disjunction< B1, Bn... >
struct | negation

## Typedefs
template<bool B, class T, class F>
using | conditional_t = typename conditional<B,T,F>::type
template<class T>
using | decay_t = typename decay<T>::type
template<bool B, class T = void>
using | enable_if_t = typename enable_if<B,T>::type
template<class T>
using | remove_reference_t = typename remove_reference<T>::type
template<class T>
using | result_of_t = typename result_of<T>::type
template<class T>
using | underlying_type_t = typename underlying_type<T>::type
template<typename... Ts>
using | void_t = typename make_void<Ts...>::type
template<bool B>
using | bool_constant = integral_constant<bool, B>
template<template< class... > class Op, class... Args>
using | is_detected = typename detail::detector<detail::nonesuch, void, Op, Args...>::value_t
template<template< class... > class Op, class... Args>
using | detected_t = typename detail::detector<detail::nonesuch, void, Op, Args...>::type
template<class Default, template< class... > class Op, class... Args>
using | detected_or = detail::detector<Default, void, Op, Args...>
template<class Default, template< class... > class Op, class... Args>
using | detected_or_t = typename detected_or<Default, Op, Args...>::type
template<class Expected, template< class... > class Op, class... Args>
using | is_detected_exact = std::is_same<Expected, detected_t<Op, Args...>>
template<class To, template< class... > class Op, class... Args>
using | is_detected_convertible = std::is_convertible<detected_t<Op, Args...>, To>
template<class T>
using | remove_cvref_t = typename remove_cvref<T>::type

## Functions
template<class CCC_, typename = ztui::ansi::EnableIfCustomColorCtor<CCC_>>
ostream & | operator<< (ostream &str, CCC_ &&color_r)
| relates: ansi::Color Stream oputput for ColorTraits enabled types Defined in namespace 'std' because namespace of 'CCC_' may vary
template<class D>
unordered_set< D > * | rwcowClone (const std::unordered_set< D > *rhs)
| clone function for RW_pointer
template<class K, class V>
std::unordered_map< K, V > * | rwcowClone (const std::unordered_map< K, V > *rhs)
| clone function for RW_pointer
template<class Tp>
std::ostream & | operator<< (std::ostream &str, const std::vector< Tp > &obj)
template<class Tp, class TCmp, class TAlloc>
std::ostream & | operator<< (std::ostream &str, const std::set< Tp, TCmp, TAlloc > &obj)
template<class Tp>
std::ostream & | operator<< (std::ostream &str, const std::unordered_set< Tp > &obj)
template<class Tp>
std::ostream & | operator<< (std::ostream &str, const std::multiset< Tp > &obj)
template<class Tp>
std::ostream & | operator<< (std::ostream &str, const std::list< Tp > &obj)
template<class TKey, class Tp>
std::ostream & | operator<< (std::ostream &str, const std::map< TKey, Tp > &obj)
template<class TKey, class Tp>
std::ostream & | operator<< (std::ostream &str, const std::unordered_map< TKey, Tp > &obj)
template<class TKey, class Tp>
std::ostream & | operator<< (std::ostream &str, const std::multimap< TKey, Tp > &obj)
std::ostream & | operator<< (std::ostream &str, const std::basic_ios< char > &obj)
| Print stream status bits.
template<class D>
std::ostream & | operator<< (std::ostream &str, const std::shared_ptr< D > &obj)
| relates: std::shared_ptr Stream output.
template<>
std::ostream & | operator<< (std::ostream &str, const std::shared_ptr< void > &obj)
std::ostream & | operator<< (std::ostream &str, const std::type_info &info)
template<class D>
std::ostream & | operator<< (std::ostream &str, const zypp::shared_ptr< D > &obj)
| relates: zypp::shared_ptr Stream output.
template<>
std::ostream & | operator<< (std::ostream &str, const zypp::shared_ptr< void > &obj)
template<class D>
std::ostream & | dumpOn (std::ostream &str, const zypp::shared_ptr< D > &obj)
| relates: zypp::shared_ptr Stream output.
template<>
std::ostream & | dumpOn (std::ostream &str, const zypp::shared_ptr< void > &obj)
template<class D>
std::ostream & | operator<< (std::ostream &str, const zypp::intrusive_ptr< D > &obj)
| relates: zypp::intrusive_ptr Stream output.
template<class D>
std::ostream & | dumpOn (std::ostream &str, const zypp::intrusive_ptr< D > &obj)
| relates: zypp::intrusive_ptr Stream output.
template<typename Functor, typename... Args>
std::enable_if< std::is_member_pointer< typenamestd::decay< Functor >::type >::value, typenamestd::result_of< Functor &&(Args &&...)>::type >::type | invoke (Functor &&f, Args &&... args)
template<typename Functor, typename... Args>
std::enable_if<!std::is_member_pointer< typenamestd::decay< Functor >::type >::value, typenamestd::result_of< Functor &&(Args &&...)>::type >::type | invoke (Functor &&f, Args &&... args)

## Variables
template<class Base, class Derived>
constexpr bool | is_base_of_v = is_base_of<Base, Derived>::value
template<class T>
constexpr bool | is_integral_v = is_integral<T>::value
template<class T>
constexpr bool | is_pointer_v = is_pointer<T>::value
template<template< class... > class Op, class... Args>
constexpr bool | is_detected_v = is_detected<Op, Args...>::value
template<class Expected, template< class... > class Op, class... Args>
constexpr bool | is_detected_exact_v = is_detected_exact<Expected, Op, Args...>::value
template<class To, template< class... > class Op, class... Args>
constexpr bool | is_detected_convertible_v = is_detected_convertible<To, Op, Args...>::value_t::value

## Typedef Documentation

## ◆ conditional_t

template<bool B, class T, class F>

using std::conditional_t = typename conditional<B,T,F>::type

Definition at line 39 of file TypeTraits.h.

## ◆ decay_t

template<class T>

using std::decay_t = typename decay<T>::type

Definition at line 42 of file TypeTraits.h.

## ◆ enable_if_t

template<bool B, class T = void>

using std::enable_if_t = typename enable_if<B,T>::type

Definition at line 45 of file TypeTraits.h.

## ◆ remove_reference_t

template<class T>

using std::remove_reference_t = typename remove_reference<T>::type

Definition at line 48 of file TypeTraits.h.

## ◆ result_of_t

template<class T>

using std::result_of_t = typename result_of<T>::type

Definition at line 51 of file TypeTraits.h.

## ◆ underlying_type_t

template<class T>

using std::underlying_type_t = typename underlying_type<T>::type

Definition at line 54 of file TypeTraits.h.

## ◆ void_t

template<typename... Ts>

using std::void_t = typename make_void<Ts...>::type

Definition at line 12 of file type_traits.h.

## ◆ bool_constant

template<bool B>

using std::bool_constant = integral_constant<bool, B>

Definition at line 45 of file type_traits.h.

## ◆ is_detected

template<template< class... > class Op, class... Args>

using std::is_detected = typename detail::detector<detail::nonesuch, void, Op, Args...>::value_t

Definition at line 48 of file type_traits.h.

## ◆ detected_t

template<template< class... > class Op, class... Args>

using std::detected_t = typename detail::detector<detail::nonesuch, void, Op, Args...>::type

Definition at line 51 of file type_traits.h.

## ◆ detected_or

template<class Default, template< class... > class Op, class... Args>

using std::detected_or = detail::detector<Default, void, Op, Args...>

Definition at line 54 of file type_traits.h.

## ◆ detected_or_t

template<class Default, template< class... > class Op, class... Args>

using std::detected_or_t = typename detected_or<Default, Op, Args...>::type

Definition at line 60 of file type_traits.h.

## ◆ is_detected_exact

template<class Expected, template< class... > class Op, class... Args>

using std::is_detected_exact = std::is_same<Expected, detected_t<Op, Args...>>

Definition at line 63 of file type_traits.h.

## ◆ is_detected_convertible

template<class To, template< class... > class Op, class... Args>

using std::is_detected_convertible = std::is_convertible<detected_t<Op, Args...>, To>

Definition at line 69 of file type_traits.h.

## ◆ remove_cvref_t

template<class T>

using std::remove_cvref_t = typename remove_cvref<T>::type

Definition at line 83 of file type_traits.h.

## Function Documentation

## ◆ operator<<() [1/16]

template<class CCC_, typename = ztui::ansi::EnableIfCustomColorCtor<CCC_>>

ostream & std::operator<< | ( | ostream & | str,
|  | CCC_ && | color_r )
| inline

relates: ansi::Color Stream oputput for ColorTraits enabled types Defined in namespace 'std' because namespace of 'CCC_' may vary

Definition at line 860 of file ansi.h.

## ◆ rwcowClone() [1/2]

template<class D>

unordered_set< D > * std::rwcowClone | ( | const std::unordered_set< D > * | rhs | ) |
| inline

clone function for RW_pointer

Definition at line 41 of file Hash.h.

## ◆ rwcowClone() [2/2]

template<class K, class V>

std::unordered_map< K, V > * std::rwcowClone | ( | const std::unordered_map< K, V > * | rhs | ) |
| inline

clone function for RW_pointer

Definition at line 46 of file Hash.h.

## ◆ operator<<() [2/16]

template<class Tp>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::vector< Tp > & | obj )

Definition at line 496 of file LogTools.h.

## ◆ operator<<() [3/16]

template<class Tp, class TCmp, class TAlloc>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::set< Tp, TCmp, TAlloc > & | obj )

Definition at line 500 of file LogTools.h.

## ◆ operator<<() [4/16]

template<class Tp>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::unordered_set< Tp > & | obj )

Definition at line 504 of file LogTools.h.

## ◆ operator<<() [5/16]

template<class Tp>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::multiset< Tp > & | obj )

Definition at line 508 of file LogTools.h.

## ◆ operator<<() [6/16]

template<class Tp>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::list< Tp > & | obj )

Definition at line 512 of file LogTools.h.

## ◆ operator<<() [7/16]

template<class TKey, class Tp>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::map< TKey, Tp > & | obj )

Definition at line 718 of file LogTools.h.

## ◆ operator<<() [8/16]

template<class TKey, class Tp>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::unordered_map< TKey, Tp > & | obj )

Definition at line 722 of file LogTools.h.

## ◆ operator<<() [9/16]

template<class TKey, class Tp>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::multimap< TKey, Tp > & | obj )

Definition at line 726 of file LogTools.h.

## ◆ operator<<() [10/16]

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::basic_ios< char > & | obj )
| inline

Print stream status bits.

Prints the values of a streams `good`, `eof`, `failed` and `bad` bit.

[g___] - good
[_eF_] - eof and fail bit set
[__FB] - fail and bad bit set

Definition at line 738 of file LogTools.h.

## ◆ operator<<() [11/16]

template<class D>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::shared_ptr< D > & | obj )
| inline

relates: std::shared_ptr Stream output.

Definition at line 816 of file LogTools.h.

## ◆ operator<<() [12/16]

template<>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::shared_ptr< void > & | obj )
| inline

Definition at line 824 of file LogTools.h.

## ◆ operator<<() [13/16]

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const std::type_info & | info )
| inline

Write type info to stream @TODO de-inline me

Definition at line 835 of file LogTools.h.

## ◆ operator<<() [14/16]

template<class D>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const zypp::shared_ptr< D > & | obj )
| inline

relates: zypp::shared_ptr Stream output.

Definition at line 133 of file PtrTypes.h.

## ◆ operator<<() [15/16]

template<>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const zypp::shared_ptr< void > & | obj )
| inline

Definition at line 141 of file PtrTypes.h.

## ◆ dumpOn() [1/3]

template<class D>

std::ostream & std::dumpOn | ( | std::ostream & | str,
|  | const zypp::shared_ptr< D > & | obj )
| inline

relates: zypp::shared_ptr Stream output.

Definition at line 150 of file PtrTypes.h.

## ◆ dumpOn() [2/3]

template<>

std::ostream & std::dumpOn | ( | std::ostream & | str,
|  | const zypp::shared_ptr< void > & | obj )
| inline

Definition at line 158 of file PtrTypes.h.

## ◆ operator<<() [16/16]

template<class D>

std::ostream & std::operator<< | ( | std::ostream & | str,
|  | const zypp::intrusive_ptr< D > & | obj )
| inline

relates: zypp::intrusive_ptr Stream output.

Definition at line 163 of file PtrTypes.h.

## ◆ dumpOn() [3/3]

template<class D>

std::ostream & std::dumpOn | ( | std::ostream & | str,
|  | const zypp::intrusive_ptr< D > & | obj )
| inline

relates: zypp::intrusive_ptr Stream output.

Definition at line 171 of file PtrTypes.h.

## ◆ invoke() [1/2]

template<typename Functor, typename... Args>

std::enable_if< std::is_member_pointer< typenamestd::decay< Functor >::type >::value, typenamestd::result_of< Functor &&(Args &&...)>::type >::type std::invoke | ( | Functor && | f,
|  | Args &&... | args )

Definition at line 32 of file functional.h.

## ◆ invoke() [2/2]

template<typename Functor, typename... Args>

std::enable_if<!std::is_member_pointer< typenamestd::decay< Functor >::type >::value, typenamestd::result_of< Functor &&(Args &&...)>::type >::type std::invoke | ( | Functor && | f,
|  | Args &&... | args )

Definition at line 41 of file functional.h.

## Variable Documentation

## ◆ is_base_of_v

template<class Base, class Derived>

bool std::is_base_of_v = is_base_of<Base, Derived>::value
| inlineconstexpr

Definition at line 27 of file TypeTraits.h.

## ◆ is_integral_v

template<class T>

bool std::is_integral_v = is_integral<T>::value
| inlineconstexpr

Definition at line 30 of file TypeTraits.h.

## ◆ is_pointer_v

template<class T>

bool std::is_pointer_v = is_pointer<T>::value
| inlineconstexpr

Definition at line 33 of file TypeTraits.h.

## ◆ is_detected_v

template<template< class... > class Op, class... Args>

bool std::is_detected_v = is_detected<Op, Args...>::value
| constexpr

Definition at line 57 of file type_traits.h.

## ◆ is_detected_exact_v

template<class Expected, template< class... > class Op, class... Args>

bool std::is_detected_exact_v = is_detected_exact<Expected, Op, Args...>::value
| constexpr

Definition at line 66 of file type_traits.h.

## ◆ is_detected_convertible_v

template<class To, template< class... > class Op, class... Args>

bool std::is_detected_convertible_v = is_detected_convertible<To, Op, Args...>::value_t::value
| constexpr

Definition at line 72 of file type_traits.h.